commit 00967465fe8093661a4d42356821eeb04170e09d
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Aug 19 12:48:40 2021

    libstdc++: Fix move construction of std::tuple with array elements [PR101960]
    
    An array member cannot be direct-initialized in a ctor-initializer-list,
    so use the base class' move constructor, which does the right thing for
    both arrays and non-arrays.
    
    This constructor could be defaulted, but that would make it trivial for
    some specializations, which would change the argument passing ABI. Do
    that for the versioned namespace only.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/101960
            * include/std/tuple (_Tuple_impl(_Tuple_impl&&)): Use base
            class' move constructor. Define as defaulted for versioned
            namespace.
            * testsuite/20_util/tuple/cons/101960.cc: New test.
    
    (cherry picked from commit 0187e0d7360f327f88d8b2294668669306ae4630)

diff --git a/libstdc++-v3/include/std/tuple b/libstdc++-v3/include/std/tuple
index d2574a3a7cc..23fad918c57 100644
--- a/libstdc++-v3/include/std/tuple
+++ b/libstdc++-v3/include/std/tuple
@@ -453,11 +453,15 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       // 2729. Missing SFINAE on std::pair::operator=
       _Tuple_impl& operator=(const _Tuple_impl&) = delete;
 
+#if _GLIBCXX_INLINE_VERSION
+      _Tuple_impl(_Tuple_impl&&) = default;
+#else
       constexpr
       _Tuple_impl(_Tuple_impl&& __in)
       noexcept(is_nothrow_move_constructible<_Head>::value)
-      : _Base(std::forward<_Head>(_M_head(__in)))
+      : _Base(static_cast<_Base&&>(__in))
       { }
+#endif
 
       template<typename _UHead>
 	constexpr
diff --git a/libstdc++-v3/testsuite/20_util/tuple/cons/101960.cc b/libstdc++-v3/testsuite/20_util/tuple/cons/101960.cc
new file mode 100644
index 00000000000..f14604cdc69
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/tuple/cons/101960.cc
@@ -0,0 +1,4 @@
+// { dg-do compile { target c++11 } }
+#include <tuple>
+std::tuple<int[1]> t;
+auto tt = std::move(t); // PR libstdc++/101960

